﻿; DisableMaxButton.ahk[UTF-8] (2024/03/16 12:00)
; for AutoHotKey v2.0.12.0 or later
;
; 最大化して使うことのないアプリの最大化ボタンを無効にする
; ※Win32APIに乗っ取らずに独自のシステムメニューアイコンを実装しているアプリケーション
;   では効きません。Firefox, Thunderbird, Chrome などが対象外となります。
;

/* 変数初期化 */
Path := Array()
IniFile := "DisableMaxButton.ini"
IniSect := "APP"

;iniファイルから件数を読み込む
count := IniRead(IniFile, IniSect, "MAX", 0)
if( count = 0 ){
	MsgBox("iniファイルに定義がありません")
	ExitApp()
}
NextWait := Number(IniRead(IniFile, IniSect, "NextWait", "10"))
LoopWait := Number(IniRead(IniFile, IniSect, "LoopWait", "100"))
ExecWait := Number(IniRead(IniFile, IniSect, "ExecWait", "250"))
idx := 1
while( count > 0 ){
	;フルパスの読み込み(PATH1～)
	strTemp := IniRead(IniFile, IniSect, "PATH" String(idx), "")
	Path.Push( strTemp )
	count := count - 1
	idx := idx + 1
}

idx := 1
WS_MAXIMIZEBOX  := 0x10000    ;最大化ボタンが有効である(取得用)
DS_MAXIMIZEBOX  := "-0x10000" ;最大化ボタンを無効にする(設定変更用)

/* 順次対象ウィンドウかどうかを調べてスタイル変更 */
Loop
{
	while( Path.Length >= idx ){
		Style := 0
		hWnd := WinActive( "ahk_exe " Path[idx] )
		if( hWnd != 0 ){
			;MsgBox( "Path=" Path[idx] )
			;//マウスのドラッグ操作中やスクロール中は動作させない
			IsDown1 := GetKeyState("LButton") or GetKeyState("RButton") or GetKeyState("MButton")
			IsDown2 := GetKeyState("WheelUp") or GetKeyState("WheelDown") or GetKeyState("WheelLeft") or GetKeyState("WheelRight")
			if( IsDown1 = 0 and IsDown2 = 0 ){
				try{
					Style := WinGetStyle( "ahk_id " hWnd )
				} catch Error as err {
					hWnd := 0
					Style := 0
				}
				if( Style & WS_MAXIMIZEBOX and hWnd != 0 ){
					;MsgBox( Format( "0x{1:x}", Style ) )
					try{
						;起動直後などウィンドウ構築中にウィンドウスタイルを変更するとハングアップすることがあるので少し待つ
						Sleep(ExecWait)
						WinSetStyle( DS_MAXIMIZEBOX, "ahk_id " hWnd )
					} catch Error as err {
						;
					}
				}
			}
		}
		idx := idx + 1
		Sleep(NextWait)
	}
	idx := 1
	Sleep(LoopWait)
}

